#include <iostream.h>
#include <fstream.h>
#include <math.h>

#define M  4
#define N  3

int gordan(double **a, int n, int m)
{
  int i, j, k, ir, u;
  double b[N][M];
  double s;
  ofstream out("1.txt");

  for (int ii = 0; ii < N; ii++)
  {
    for (int j = 0; j < M; j++)
      out << a[ii][j] << "  ";
    out << "\n";
  }
    out << "\n";

  for (i = 0; i < n; i++)
  {
    s = 0;
    for (j = 0; j < m - 1; j++)
    {
      if (fabs(a[i][j]) > 0)
      {
        s = a[i][j];
        ir = j;
        break;
      }
    }
    if (s == 0)
    {
      out << i << "_____" << j << "\n";
      return 1;
    }
    for (k = 0; k < n; k++)
    {
      if (k != i)
      {
        for (u = 0; u < m - 1; u++)
          b[k][u] = a[k][u] - (a[k][ir] * a[i][u] / s);
        b[k][m - 1] = a[k][m - 1] - a[k][ir] * a[i][m - 1] / s;
      }
      else
        for (u = 0; u < m; u++)
          b[k][u] = a[k][u];
    }

  out << "ir=" << ir << "\n";
  for (int ii = 0; ii < N; ii++)
  {
    for (int j = 0; j < M; j++)
    {
      out << b[ii][j] << "  ";
      a[ii][j] = b[ii][j];
    }
    out << "\n";
  }
    out << "\n";

  }
  out.close();
  return 0;
}

void main()
{
  double **data;
  ifstream in("input.txt");

  data = new double*[N];

  for (int i = 0; i < N; i++)
  {
    data[i] = new double[M];
    for (int j = 0; j < M; j++)
    {
      in >> data[i][j];
    }
  }
  in.close();

  cout << "Gordan is: " << gordan(data, N, M) << "\n";
}
